
local StoneGateV6 = ...

-- Apply building asset processor
StoneGateV6:registerAssetProcessor("models/woodenFloors/woodenFloorMain.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV6:registerAssetProcessor("models/woodenFloors/woodenFloorKeep.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV6:registerAssetProcessor("models/woodenFloors/woodenFloorSmallSquaredTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV6:registerAssetProcessor("models/woodenFloors/woodenFloorCircularTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV6:registerAssetProcessor("models/woodenFloors/woodenFloorOctogonalTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})
StoneGateV6:registerAssetProcessor("models/woodenFloors/woodenFloorSmallCircularTower.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

function registerRoofPart(_nameFbxFile, _nameFbx, _nameAsset)
    StoneGateV6:registerAssetId("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB")

-- Register the stone gate set decoration roof part
    StoneGateV6:register({
	DataType = "BUILDING_PART",
	Id = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PART",
	Name = StoneGateSetPrefix .. "_" .. _nameAsset .. "_NAME",
	Description = StoneGateSetPrefix .. "_" .. _nameAsset .. "_DESC",
	Category = "EXTENSION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = StoneGateSetPrefix .. "_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "PLANK", Quantity = 5 }
		}
	}
    })

    StoneGateV6:registerPrefabComponent("models/woodenFloors/" .. _nameFbxFile .. ".fbx/Prefab/woodenFloor/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MAJOR",
	BuildingZone = { 0, 0 }
    })
end

registerRoofPart( "woodenFloorMain", "step_2_WFMainA", "WFMAIN_A" )
registerRoofPart( "woodenFloorKeep", "step_2_WFKeepA", "WFKEEP_A" )
registerRoofPart( "woodenFloorSmallSquaredTower", "step_2_WFSstA", "WFSST_A" )
registerRoofPart( "woodenFloorCircularTower", "step_2_WFCircularA", "WFCIRCULAR_A" )
registerRoofPart( "woodenFloorOctogonalTower", "step_2_WFOctogonalA", "WFOCTOGONAL_A" )
registerRoofPart( "woodenFloorSmallCircularTower", "step_2_WFSctA", "WFSCT_A" )
registerRoofPart( "woodenFloorMain", "step_2_WFMainB", "WFMAIN_B" )
registerRoofPart( "woodenFloorKeep", "step_2_WFKeepB", "WFKEEP_B" )
registerRoofPart( "woodenFloorSmallSquaredTower", "step_2_WFSstB", "WFSST_B" )
registerRoofPart( "woodenFloorCircularTower", "step_2_WFCircularB", "WFCIRCULAR_B" )
registerRoofPart( "woodenFloorOctogonalTower", "step_2_WFOctogonalB", "WFOCTOGONAL_B" )
registerRoofPart( "woodenFloorSmallCircularTower", "step_2_WFSctB", "WFSCT_B" )
registerRoofPart( "woodenFloorMain", "step_2_WFMainC", "WFMAIN_C" )
registerRoofPart( "woodenFloorKeep", "step_2_WFKeepC", "WFKEEP_C" )
registerRoofPart( "woodenFloorSmallSquaredTower", "step_2_WFSstC", "WFSST_C" )
registerRoofPart( "woodenFloorCircularTower", "step_2_WFCircularC", "WFCIRCULAR_C" )
registerRoofPart( "woodenFloorOctogonalTower", "step_2_WFOctogonalC", "WFOCTOGONAL_C" )
registerRoofPart( "woodenFloorSmallCircularTower", "step_2_WFSctC", "WFSCT_C" )
